unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  ExtCtrls, StdCtrls, DsGraphicRuler, DSCustomGraphicRuler;

type
  TForm1 = class(TForm)
    DSGraphicRuler1: TDSGraphicRuler;
    DSGraphicRuler2: TDSGraphicRuler;
    DSGraphicRuler4: TDSGraphicRuler;
    DSGraphicRuler3: TDSGraphicRuler;
    Panel2: TPanel;
    ComboBox1: TComboBox;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    ComboBox2: TComboBox;
    Label3: TLabel;
    CheckBox2: TCheckBox;
    procedure ComboBox1Change(Sender: TObject);
    procedure Panel2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Panel2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox1Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private declarations }
    fIsMouseDown: Boolean;
    fLastMousePos: TPoint;
  public
    { Public declarations }
    procedure setRulersMeasure(aMeasure: TRulerMeasure);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  fIsMouseDown := False;

end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
  ScaleFactor: Double;
begin
  ScaleFactor := 100 / StrToInt(ComboBox1.Text);

  DSGraphicRuler1.ScaleFactor := ScaleFactor;
  DSGraphicRuler2.ScaleFactor := ScaleFactor;
  DSGraphicRuler3.ScaleFactor := ScaleFactor;
  DSGraphicRuler4.ScaleFactor := ScaleFactor;
end;

procedure TForm1.Panel2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  fIsMouseDown := True;
  fLastMousePos := Point(X, Y);
end;

procedure TForm1.Panel2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  vTemp: Double;
begin
  if fIsMouseDown then begin
    vTemp := DSGraphicRuler1.PixelToFormat(X - fLastMousePos.X);
    if CheckBox1.Checked then
      vTemp := -vTemp;
    DSGraphicRuler1.StartPos := DSGraphicRuler1.StartPos - vTemp;
    DSGraphicRuler3.StartPos := DSGraphicRuler1.StartPos;

    vTemp := DSGraphicRuler2.PixelToFormat(Y - fLastMousePos.Y);
    if CheckBox1.Checked then
      vTemp := -vTemp;
    DSGraphicRuler2.StartPos := DSGraphicRuler2.StartPos - vTemp;
    DSGraphicRuler4.StartPos := DSGraphicRuler2.StartPos;

    fLastMousePos := Point(X, Y);
  end;

  DSGraphicRuler1.Track.Position := X;
  DSGraphicRuler3.Track.Position := X;
  DSGraphicRuler2.Track.Position := Y;
  DSGraphicRuler4.Track.Position := Y;
  DSGraphicRuler1.Refresh;
  DSGraphicRuler2.Refresh;
  DSGraphicRuler3.Refresh;
  DSGraphicRuler4.Refresh;
end;

procedure TForm1.Panel2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  fIsMouseDown := False;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  DSGraphicRuler1.Opposite := CheckBox1.Checked;
  DSGraphicRuler3.Opposite := CheckBox1.Checked;
  DSGraphicRuler2.Opposite := CheckBox1.Checked;
  DSGraphicRuler4.Opposite := CheckBox1.Checked;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  case ComboBox2.ItemIndex of
    0: setRulersMeasure(rmMm);
    1: setRulersMeasure(rmCm);
    2: setRulersMeasure(rmM);
    3: setRulersMeasure(rmInch);
    4: setRulersMeasure(rmPixel);
  end;
end;

procedure TForm1.setRulersMeasure(aMeasure: TRulerMeasure);
begin
  DSGraphicRuler1.Measure := aMeasure;
  DSGraphicRuler2.Measure := aMeasure;
  DSGraphicRuler3.Measure := aMeasure;
  DSGraphicRuler4.Measure := aMeasure;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  DSGraphicRuler1.MeasureVisible := CheckBox2.Checked;
  DSGraphicRuler2.MeasureVisible := CheckBox2.Checked;
  DSGraphicRuler3.MeasureVisible := CheckBox2.Checked;
  DSGraphicRuler4.MeasureVisible := CheckBox2.Checked;
end;

end.
